JUCE: Slider Class Reference

JUCE

Classes | Public Types | Public Member Functions | Public Attributes | List of all members
Slider Class Reference
juce_gui_basics » widgets

A slider control for changing a value. More...

`#include <juce_Slider.h>`

Inheritance diagram for Slider:

## Classes
class | Listener
| A class for receiving callbacks from a Slider. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide slider drawing functionality. More...
struct | RotaryParameters
| Structure defining rotary parameters for a slider. More...
class | ScopedDragNotification
| An RAII class for sending slider listener drag messages. More...
struct | SliderLayout
| A struct defining the placement of the slider area and the text box area relative to the bounds of the whole Slider component. More...

## Public Types
enum | SliderStyle { LinearHorizontal , LinearVertical , LinearBar , LinearBarVertical , Rotary , RotaryHorizontalDrag , RotaryVerticalDrag , RotaryHorizontalVerticalDrag , IncDecButtons , TwoValueHorizontal , TwoValueVertical , ThreeValueHorizontal , ThreeValueVertical }
| The types of slider available. More...
enum | TextEntryBoxPosition { NoTextBox , TextBoxLeft , TextBoxRight , TextBoxAbove , TextBoxBelow }
| The position of the slider's text-entry box. More...
enum | DragMode { notDragging , absoluteDrag , velocityDrag }
| Describes the type of mouse-dragging that is happening when a value is being changed. More...
enum | IncDecButtonMode { incDecButtonsNotDraggable , incDecButtonsDraggable_AutoDirection , incDecButtonsDraggable_Horizontal , incDecButtonsDraggable_Vertical }
| Used by setIncDecButtonsMode(). More...
enum | ColourIds { backgroundColourId = 0x1001200 , thumbColourId = 0x1001300 , trackColourId = 0x1001310 , rotarySliderFillColourId = 0x1001311 , rotarySliderOutlineColourId = 0x1001312 , textBoxTextColourId = 0x1001400 , textBoxBackgroundColourId = 0x1001500 , textBoxHighlightColourId = 0x1001600 , textBoxOutlineColourId = 0x1001700 }
| A set of colour IDs to use to change the colour of various aspects of the slider. More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...

## Public Member Functions
| Slider ()
| Creates a slider. More...
| Slider (const String &componentName)
| Creates a slider. More...
| Slider (SliderStyle style, TextEntryBoxPosition textBoxPosition)
| Creates a slider with some explicit options. More...
| ~Slider () override
| Destructor. More...
void | setSliderStyle (SliderStyle newStyle)
| Changes the type of slider interface being used. More...
SliderStyle | getSliderStyle () const noexcept
| Returns the slider's current style. More...
void | setRotaryParameters (RotaryParameters newParameters) noexcept
| Changes the properties of a rotary slider. More...
void | setRotaryParameters (float startAngleRadians, float endAngleRadians, bool stopAtEnd) noexcept
| Changes the properties of a rotary slider. More...
RotaryParameters | getRotaryParameters () const noexcept
| Changes the properties of a rotary slider. More...
void | setMouseDragSensitivity (int distanceForFullScaleDrag)
| Sets the distance the mouse has to move to drag the slider across the full extent of its range. More...
int | getMouseDragSensitivity () const noexcept
| Returns the current sensitivity value set by setMouseDragSensitivity(). More...
void | setVelocityBasedMode (bool isVelocityBased)
| Changes the way the mouse is used when dragging the slider. More...
bool | getVelocityBasedMode () const noexcept
| Returns true if velocity-based mode is active. More...
void | setVelocityModeParameters (double sensitivity=1.0, int threshold=1, double offset=0.0, bool userCanPressKeyToSwapMode=true, ModifierKeys::Flags modifiersToSwapModes=ModifierKeys::ctrlAltCommandModifiers)
| Changes aspects of the scaling used when in velocity-sensitive mode. More...
double | getVelocitySensitivity () const noexcept
| Returns the velocity sensitivity setting. More...
int | getVelocityThreshold () const noexcept
| Returns the velocity threshold setting. More...
double | getVelocityOffset () const noexcept
| Returns the velocity offset setting. More...
bool | getVelocityModeIsSwappable () const noexcept
| Returns the velocity user key setting. More...
void | setSkewFactor (double factor, bool symmetricSkew=false)
| Sets up a skew factor to alter the way values are distributed. More...
void | setSkewFactorFromMidPoint (double sliderValueToShowAtMidPoint)
| Sets up a skew factor to alter the way values are distributed. More...
double | getSkewFactor () const noexcept
| Returns the current skew factor. More...
bool | isSymmetricSkew () const noexcept
| Returns the whether the skew is symmetric from the midpoint to both sides. More...
void | setIncDecButtonsMode (IncDecButtonMode mode)
| When the style is IncDecButtons, this lets you turn on a mode where the mouse can be dragged on the buttons to drag the values. More...
void | setTextBoxStyle (TextEntryBoxPosition newPosition, bool isReadOnly, int textEntryBoxWidth, int textEntryBoxHeight)
| Changes the location and properties of the text-entry box. More...
TextEntryBoxPosition | getTextBoxPosition () const noexcept
| Returns the status of the text-box. More...
int | getTextBoxWidth () const noexcept
| Returns the width used for the text-box. More...
int | getTextBoxHeight () const noexcept
| Returns the height used for the text-box. More...
void | setTextBoxIsEditable (bool shouldBeEditable)
| Makes the text-box editable. More...
bool | isTextBoxEditable () const noexcept
| Returns true if the text-box is read-only. More...
void | showTextBox ()
| If the text-box is editable, this will give it the focus so that the user can type directly into it. More...
void | hideTextBox (bool discardCurrentEditorContents)
| If the text-box currently has focus and is being edited, this resets it and takes keyboard focus away from it. More...
void | setValue (double newValue, NotificationType notification=sendNotificationAsync)
| Changes the slider's current value. More...
double | getValue () const
| Returns the slider's current value. More...
Value & | getValueObject () noexcept
| Returns the Value object that represents the slider's current position. More...
void | setRange (double newMinimum, double newMaximum, double newInterval=0)
| Sets the limits that the slider's value can take. More...
void | setRange (Range< double > newRange, double newInterval)
| Sets the limits that the slider's value can take. More...
void | setNormalisableRange (NormalisableRange< double > newNormalisableRange)
| Sets a NormalisableRange to use for the Slider values. More...
Range< double > | getRange () const noexcept
| Returns the slider's range. More...
double | getMaximum () const noexcept
| Returns the current maximum value. More...
double | getMinimum () const noexcept
| Returns the current minimum value. More...
double | getInterval () const noexcept
| Returns the current step-size for values. More...
double | getMinValue () const
| For a slider with two or three thumbs, this returns the lower of its values. More...
Value & | getMinValueObject () noexcept
| For a slider with two or three thumbs, this returns the lower of its values. More...
void | setMinValue (double newValue, NotificationType notification=sendNotificationAsync, bool allowNudgingOfOtherValues=false)
| For a slider with two or three thumbs, this sets the lower of its values. More...
double | getMaxValue () const
| For a slider with two or three thumbs, this returns the higher of its values. More...
Value & | getMaxValueObject () noexcept
| For a slider with two or three thumbs, this returns the higher of its values. More...
void | setMaxValue (double newValue, NotificationType notification=sendNotificationAsync, bool allowNudgingOfOtherValues=false)
| For a slider with two or three thumbs, this sets the lower of its values. More...
void | setMinAndMaxValues (double newMinValue, double newMaxValue, NotificationType notification=sendNotificationAsync)
| For a slider with two or three thumbs, this sets the minimum and maximum thumb positions. More...
void | addListener (Listener *listener)
| Adds a listener to be called when this slider's value changes. More...
void | removeListener (Listener *listener)
| Removes a previously-registered listener. More...
void | setDoubleClickReturnValue (bool shouldDoubleClickBeEnabled, double valueToSetOnDoubleClick, ModifierKeys singleClickModifiers=ModifierKeys::altModifier)
| This lets you choose whether double-clicking or single-clicking with a specified key modifier moves the slider to a given position. More...
double | getDoubleClickReturnValue () const noexcept
| Returns the values last set by setDoubleClickReturnValue() method. More...
bool | isDoubleClickReturnEnabled () const noexcept
| Returns true if double-clicking to reset to a default value is enabled. More...
void | setChangeNotificationOnlyOnRelease (bool onlyNotifyOnRelease)
| Tells the slider whether to keep sending change messages while the user is dragging the slider. More...
void | setSliderSnapsToMousePosition (bool shouldSnapToMouse)
| This lets you change whether the slider thumb jumps to the mouse position when you click. More...
bool | getSliderSnapsToMousePosition () const noexcept
| Returns true if setSliderSnapsToMousePosition() has been enabled. More...
void | setPopupDisplayEnabled (bool shouldShowOnMouseDrag, bool shouldShowOnMouseHover, Component *parentComponentToUse, int hoverTimeout=2000)
| If enabled, this gives the slider a pop-up bubble which appears while the slider is being dragged or hovered-over. More...
Component * | getCurrentPopupDisplay () const noexcept
| If a popup display is enabled and is currently visible, this returns the component that is being shown, or nullptr if none is currently in use. More...
void | setPopupMenuEnabled (bool menuEnabled)
| If this is set to true, then right-clicking on the slider will pop-up a menu to let the user change the way it works. More...
void | setScrollWheelEnabled (bool enabled)
| This can be used to stop the mouse scroll-wheel from moving the slider. More...
bool | isScrollWheelEnabled () const noexcept
| Returns true if the scroll wheel can move the slider. More...
int | getThumbBeingDragged () const noexcept
| Returns a number to indicate which thumb is currently being dragged by the mouse. More...
virtual void | startedDragging ()
| Callback to indicate that the user is about to start dragging the slider. More...
virtual void | stoppedDragging ()
| Callback to indicate that the user has just stopped dragging the slider. More...
virtual void | valueChanged ()
| Callback to indicate that the user has just moved the slider. More...
virtual double | getValueFromText (const String &text)
| Subclasses can override this to convert a text string to a value. More...
virtual String | getTextFromValue (double value)
| Turns the slider's current value into a text string. More...
void | setTextValueSuffix (const String &suffix)
| Sets a suffix to append to the end of the numeric value when it's displayed as a string. More...
String | getTextValueSuffix () const
| Returns the suffix that was set by setTextValueSuffix(). More...
int | getNumDecimalPlacesToDisplay () const noexcept
| Returns the best number of decimal places to use when displaying this slider's value. More...
void | setNumDecimalPlacesToDisplay (int decimalPlacesToDisplay)
| Modifies the best number of decimal places to use when displaying this slider's value. More...
virtual double | proportionOfLengthToValue (double proportion)
| Allows a user-defined mapping of distance along the slider to its value. More...
virtual double | valueToProportionOfLength (double value)
| Allows a user-defined mapping of value to the position of the slider along its length. More...
float | getPositionOfValue (double value) const
| Returns the X or Y coordinate of a value along the slider's length. More...
virtual double | snapValue (double attemptedValue, DragMode dragMode)
| This can be overridden to allow the slider to snap to user-definable values. More...
void | updateText ()
| This can be called to force the text box to update its contents. More...
bool | isHorizontal () const noexcept
| True if the slider moves horizontally. More...
bool | isVertical () const noexcept
| True if the slider moves vertically. More...
bool | isRotary () const noexcept
| True if the slider is in a rotary mode. More...
bool | isBar () const noexcept
| True if the slider is in a linear bar mode. More...
bool | isTwoValue () const noexcept
| True if the slider has two thumbs. More...
bool | isThreeValue () const noexcept
| True if the slider has three thumbs. More...
void | paint (Graphics &) override
void | resized () override
void | mouseDown (const MouseEvent &) override
void | mouseUp (const MouseEvent &) override
void | mouseDrag (const MouseEvent &) override
void | mouseDoubleClick (const MouseEvent &) override
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
void | modifierKeysChanged (const ModifierKeys &) override
void | lookAndFeelChanged () override
void | enablementChanged () override
void | focusOfChildComponentChanged (FocusChangeType) override
void | colourChanged () override
void | mouseMove (const MouseEvent &) override
void | mouseExit (const MouseEvent &) override
void | mouseEnter (const MouseEvent &) override
bool | keyPressed (const KeyPress &) override
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component. More...
| ~Component () override
| Destructor. More...
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time. More...
String | getName () const noexcept
| Returns the name of this component. More...
virtual void | setName (const String &newName)
| Sets the name of this component. More...
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID(). More...
void | setComponentID (const String &newID)
| Sets the component's ID string. More...
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible. More...
bool | isVisible () const noexcept
| Tests whether the component is visible or not. More...
virtual void | visibilityChanged ()
| Called when this component's visibility changes. More...
bool | isShowing () const
| Tests whether this component and all its parents are visible. More...
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop. More...
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it. More...
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop. More...
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component. More...
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window. More...
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised. More...
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop. More...
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings. More...
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings. More...
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component. More...
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings. More...
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings. More...
int | getX () const noexcept
| Returns the x coordinate of the component's left edge. More...
int | getY () const noexcept
| Returns the y coordinate of the top of this component. More...
int | getWidth () const noexcept
| Returns the component's width in pixels. More...
int | getHeight () const noexcept
| Returns the component's height in pixels. More...
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge. More...
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point. More...
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component. More...
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box. More...
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin. More...
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers. More...
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin. More...
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin. More...
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left. More...
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left. More...
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position. More...
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position. More...
void | setTopRightPosition (int x, int y)
| Moves the component to a new position. More...
void | setSize (int newWidth, int newHeight)
| Changes the size of the component. More...
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size. More...
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size. More...
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it. More...
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged. More...
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre. More...
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre. More...
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre. More...
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent. More...
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component. More...
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component. More...
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component. More...
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width. More...
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height. More...
int | getParentWidth () const noexcept
| Returns the width of the component's parent. More...
int | getParentHeight () const noexcept
| Returns the height of the component's parent. More...
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component. More...
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains. More...
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index. More...
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components. More...
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components. More...
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID. More...
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one. More...
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one. More...
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID. More...
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components. More...
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index. More...
void | removeAllChildren ()
| Removes all this component's children. More...
void | deleteAllChildren ()
| Removes and deletes all of this component's children. More...
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside. More...
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class. More...
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents. More...
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children. More...
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed. More...
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes. More...
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component. More...
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method. More...
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags. More...
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one. More...
void | repaint ()
| Marks the whole component as needing to be redrawn. More...
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn. More...
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn. More...
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing. More...
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component. More...
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context. More...
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted. More...
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted. More...
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance. More...
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect. More...
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component. More...
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component. More...
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting. More...
void | sendLookAndFeelChange ()
| Calls the lookAndFeelChanged() method in this component and all its children. More...
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent. More...
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent. More...
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked. More...
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on. More...
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component. More...
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified. More...
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports. More...
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container. More...
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container. More...
Component * | findFocusContainer () const
| Returns the focus container for this component. More...
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component. More...
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not. More...
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus. More...
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus. More...
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus(). More...
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component. More...
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component. More...
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus. More...
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings. More...
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component. More...
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component. More...
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus. More...
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline. More...
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled. More...
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component. More...
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled. More...
float | getAlpha () const noexcept
| Returns the component's current transparency level. More...
void | setAlpha (float newAlpha)
| Changes the transparency of this component. More...
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component. More...
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component. More...
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component. More...
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated. More...
virtual void | paint (Graphics &g)
| Components can override this method to draw their content. More...
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children. More...
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component. More...
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component. More...
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component. More...
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed. More...
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down. More...
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released. More...
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component. More...
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved. More...
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used. More...
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component. More...
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component. More...
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener. More...
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives. More...
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener. More...
virtual bool | keyPressed (const KeyPress &key)
| Called when a key is pressed. More...
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released. More...
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released. More...
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus. More...
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus. More...
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component. More...
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component. More...
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component. More...
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component. More...
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component. More...
virtual void | resized ()
| Called when this component's size has been changed. More...
virtual void | moved ()
| Called when this component's position has been changed. More...
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized. More...
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized. More...
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings. More...
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position. More...
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener. More...
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component. More...
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage(). More...
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates. More...
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state. More...
void | exitModalState (int returnValue)
| Ends a component's modal state. More...
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one. More...
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages. More...
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events. More...
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component. More...
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component. More...
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component. More...
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose. More...
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it. More...
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method. More...
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component. More...
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method. More...
void * | getWindowHandle () const
| Returns the underlying native window handle for this component. More...
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component. More...
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component. More...
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting. More...
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage(). More...
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled. More...
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag. More...
String | getTitle () const noexcept
| Returns the title text for this component. More...
void | setTitle (const String &newTitle)
| Sets the title for this component. More...
String | getDescription () const noexcept
| Returns the description for this component. More...
void | setDescription (const String &newDescription)
| Sets the description for this component. More...
String | getHelpText () const noexcept
| Returns the help text for this component. More...
void | setHelpText (const String &newHelpText)
| Sets the help text for this component. More...
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients. More...
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients. More...
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible. More...
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component. More...
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor. More...
virtual void | mouseMove (const MouseEvent &event)
| Called when the mouse moves inside a component. More...
virtual void | mouseEnter (const MouseEvent &event)
| Called when the mouse first enters a component. More...
virtual void | mouseExit (const MouseEvent &event)
| Called when the mouse moves out of a component. More...
virtual void | mouseDown (const MouseEvent &event)
| Called when a mouse button is pressed. More...
virtual void | mouseDrag (const MouseEvent &event)
| Called when the mouse is moved while a button is held down. More...
virtual void | mouseUp (const MouseEvent &event)
| Called when a mouse button is released. More...
virtual void | mouseDoubleClick (const MouseEvent &event)
| Called when a mouse button has been double-clicked on a component. More...
virtual void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel)
| Called when the mouse-wheel is moved. More...
virtual void | mouseMagnify (const MouseEvent &event, float scaleFactor)
| Called when a pinch-to-zoom mouse-gesture is used. More...
Public Member Functions inherited from SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor. More...
virtual void | setTooltip (const String &newTooltip)
| Assigns a new tooltip to this object. More...
String | getTooltip () override
| Returns the tooltip assigned to this object. More...
Public Member Functions inherited from TooltipClient
virtual | ~TooltipClient ()=default
| Destructor. More...
virtual String | getTooltip ()=0
| Returns the string that this object wants to show as its tooltip. More...

## Public Attributes
std::function< void()> | onValueChange
| You can assign a lambda to this callback object to have it called when the slider value is changed. More...
std::function< void()> | onDragStart
| You can assign a lambda to this callback object to have it called when the slider's drag begins. More...
std::function< void()> | onDragEnd
| You can assign a lambda to this callback object to have it called when the slider's drag ends. More...
std::function< double(const String &)> | valueFromTextFunction
| You can assign a lambda that will be used to convert textual values to the slider's normalised position. More...
std::function< String(double)> | textFromValueFunction
| You can assign a lambda that will be used to convert the slider's normalised position to a textual value. More...

## Additional Inherited Members
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor. More...
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus. More...
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it. More...
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation. More...
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down. More...
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state. More...
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal. More...
Protected Member Functions inherited from SettableTooltipClient
| SettableTooltipClient ()=default

## Detailed Description

A slider control for changing a value.

The slider can be horizontal, vertical, or rotary, and can optionally have a text-box inside it to show an editable display of the current value.

To use it, create a Slider object and use the setSliderStyle() method to set up the type you want. To set up the text-entry box, use setTextBoxStyle().

To define the values that it can be set to, see the setRange() and setValue() methods.

There are also lots of custom tweaks you can do by subclassing and overriding some of the virtual methods, such as changing the scaling, changing the format of the text display, custom ways of limiting the values, etc.

You can register Slider::Listener objects with a slider, and they'll be called when the value changes.

See also
  Slider::Listener

## Member Enumeration Documentation

## ◆ SliderStyle

enum Slider::SliderStyle

The types of slider available.

See also
  setSliderStyle, setRotaryParameters

Enumerator
LinearHorizontal | A traditional horizontal slider.
LinearVertical | A traditional vertical slider.
LinearBar | A horizontal bar slider with the text label drawn on top of it.
LinearBarVertical | A vertical bar slider with the text label drawn on top of it.
Rotary | A rotary control that you move by dragging the mouse in a circular motion, like a knob. See also setRotaryParameters
RotaryHorizontalDrag | A rotary control that you move by dragging the mouse left-to-right. See also setRotaryParameters
RotaryVerticalDrag | A rotary control that you move by dragging the mouse up-and-down. See also setRotaryParameters
RotaryHorizontalVerticalDrag | A rotary control that you move by dragging the mouse up-and-down or left-to-right. See also setRotaryParameters
IncDecButtons | A pair of buttons that increment or decrement the slider's value by the increment set in setRange().
TwoValueHorizontal | A horizontal slider that has two thumbs instead of one, so it can show a minimum and maximum value. See also setMinValue, setMaxValue
TwoValueVertical | A vertical slider that has two thumbs instead of one, so it can show a minimum and maximum value. See also setMinValue, setMaxValue
ThreeValueHorizontal | A horizontal slider that has three thumbs instead of one, so it can show a minimum and maximum value, with the current value being somewhere between them. See also setMinValue, setMaxValue
ThreeValueVertical | A vertical slider that has three thumbs instead of one, so it can show a minimum and maximum value, with the current value being somewhere between them. See also setMinValue, setMaxValue

## ◆ TextEntryBoxPosition

enum Slider::TextEntryBoxPosition

The position of the slider's text-entry box.

See also
  setTextBoxStyle

Enumerator
NoTextBox | Doesn't display a text box.
TextBoxLeft | Puts the text box to the left of the slider, vertically centred.
TextBoxRight | Puts the text box to the right of the slider, vertically centred.
TextBoxAbove | Puts the text box above the slider, horizontally centred.
TextBoxBelow | Puts the text box below the slider, horizontally centred.

## ◆ DragMode

enum Slider::DragMode

Describes the type of mouse-dragging that is happening when a value is being changed.

See also
  snapValue

Enumerator
notDragging | Dragging is not active.
absoluteDrag | The dragging corresponds directly to the value that is displayed.
velocityDrag | The dragging value change is relative to the velocity of the mouse movement.

## ◆ IncDecButtonMode

enum Slider::IncDecButtonMode

Used by setIncDecButtonsMode().

Enumerator
incDecButtonsNotDraggable |
incDecButtonsDraggable_AutoDirection |
incDecButtonsDraggable_Horizontal |
incDecButtonsDraggable_Vertical |

## ◆ ColourIds

enum Slider::ColourIds

A set of colour IDs to use to change the colour of various aspects of the slider.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | A colour to use to fill the slider's background.
thumbColourId | The colour to draw the thumb with. It's up to the look and feel class how this is used.
trackColourId | The colour to draw the groove that the thumb moves along.
rotarySliderFillColourId | For rotary sliders, this colour fills the outer curve.
rotarySliderOutlineColourId | For rotary sliders, this colour is used to draw the outer curve's outline.
textBoxTextColourId | The colour for the text in the text-editor box used for editing the value.
textBoxBackgroundColourId | The background colour for the text-editor box.
textBoxHighlightColourId | The text highlight colour for the text-editor box.
textBoxOutlineColourId | The colour to use for a border around the text-editor box.

## Constructor & Destructor Documentation

## ◆ Slider() [1/3]

Slider::Slider | ( |  | ) |

Creates a slider.

When created, you can set up the slider's style and range with setSliderStyle(), setRange(), etc.

## ◆ Slider() [2/3]

Slider::Slider | ( | const String & | componentName | ) |
| explicit

Creates a slider.

When created, you can set up the slider's style and range with setSliderStyle(), setRange(), etc.

## ◆ Slider() [3/3]

Slider::Slider | ( | SliderStyle | style,
|  | TextEntryBoxPosition | textBoxPosition
| ) |  |

Creates a slider with some explicit options.

## ◆ ~Slider()

Slider::~Slider | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ setSliderStyle()

void Slider::setSliderStyle | ( | SliderStyle | newStyle | ) |

Changes the type of slider interface being used.

Parameters

  newStyle | the type of interface

See also
  setRotaryParameters, setVelocityBasedMode

## ◆ getSliderStyle()

SliderStyle Slider::getSliderStyle | ( |  | ) | const
| noexcept

Returns the slider's current style.

See also
  setSliderStyle

## ◆ setRotaryParameters() [1/2]

void Slider::setRotaryParameters | ( | RotaryParameters | newParameters | ) |
| noexcept

Changes the properties of a rotary slider.

## ◆ setRotaryParameters() [2/2]

void Slider::setRotaryParameters | ( | float | startAngleRadians,
|  | float | endAngleRadians,
|  | bool | stopAtEnd
| ) |  |
| noexcept

Changes the properties of a rotary slider.

## ◆ getRotaryParameters()

RotaryParameters Slider::getRotaryParameters | ( |  | ) | const
| noexcept

Changes the properties of a rotary slider.

## ◆ setMouseDragSensitivity()

void Slider::setMouseDragSensitivity | ( | int | distanceForFullScaleDrag | ) |

Sets the distance the mouse has to move to drag the slider across the full extent of its range.

This only applies when in modes like RotaryHorizontalDrag, where it's using relative mouse movements to adjust the slider.

## ◆ getMouseDragSensitivity()

int Slider::getMouseDragSensitivity | ( |  | ) | const
| noexcept

Returns the current sensitivity value set by setMouseDragSensitivity().

## ◆ setVelocityBasedMode()

void Slider::setVelocityBasedMode | ( | bool | isVelocityBased | ) |

Changes the way the mouse is used when dragging the slider.

If true, this will turn on velocity-sensitive dragging, so that the faster the mouse moves, the bigger the movement to the slider. This helps when making accurate adjustments if the slider's range is quite large.

If false, the slider will just try to snap to wherever the mouse is.

## ◆ getVelocityBasedMode()

bool Slider::getVelocityBasedMode | ( |  | ) | const
| noexcept

Returns true if velocity-based mode is active.

See also
  setVelocityBasedMode

## ◆ setVelocityModeParameters()

void Slider::setVelocityModeParameters | ( | double | sensitivity = `1.0`,
|  | int | threshold = `1`,
|  | double | offset = `0.0`,
|  | bool | userCanPressKeyToSwapMode = `true`,
|  | ModifierKeys::Flags | modifiersToSwapModes = `ModifierKeys::ctrlAltCommandModifiers`
| ) |  |

Changes aspects of the scaling used when in velocity-sensitive mode.

These apply when you've used setVelocityBasedMode() to turn on velocity mode, or if you're holding down ctrl.

Parameters

  sensitivity | higher values than 1.0 increase the range of acceleration used
  threshold | the minimum number of pixels that the mouse needs to move for it to be treated as a movement
  offset | values greater than 0.0 increase the minimum speed that will be used when the threshold is reached
  userCanPressKeyToSwapMode | if true, then the user can hold down the ctrl or command key to toggle velocity-sensitive mode
  modifiersToSwapModes | this is a set of modifier flags which will be tested when determining whether to enable/disable velocity-sensitive mode

## ◆ getVelocitySensitivity()

double Slider::getVelocitySensitivity | ( |  | ) | const
| noexcept

Returns the velocity sensitivity setting.

See also
  setVelocityModeParameters

## ◆ getVelocityThreshold()

int Slider::getVelocityThreshold | ( |  | ) | const
| noexcept

Returns the velocity threshold setting.

See also
  setVelocityModeParameters

## ◆ getVelocityOffset()

double Slider::getVelocityOffset | ( |  | ) | const
| noexcept

Returns the velocity offset setting.

See also
  setVelocityModeParameters

## ◆ getVelocityModeIsSwappable()

bool Slider::getVelocityModeIsSwappable | ( |  | ) | const
| noexcept

Returns the velocity user key setting.

See also
  setVelocityModeParameters

## ◆ setSkewFactor()

void Slider::setSkewFactor | ( | double | factor,
|  | bool | symmetricSkew = `false`
| ) |  |

Sets up a skew factor to alter the way values are distributed.

You may want to use a range of values on the slider where more accuracy is required towards one end of the range, so this will logarithmically spread the values across the length of the slider.

If the factor is < 1.0, the lower end of the range will fill more of the slider's length; if the factor is > 1.0, the upper end of the range will be expanded instead. A factor of 1.0 doesn't skew it at all.

If symmetricSkew is true, the skew factor applies from the middle of the slider to each of its ends.

To set the skew position by using a mid-point, use the setSkewFactorFromMidPoint() method instead.

See also
  getSkewFactor, setSkewFactorFromMidPoint, isSymmetricSkew

## ◆ setSkewFactorFromMidPoint()

void Slider::setSkewFactorFromMidPoint | ( | double | sliderValueToShowAtMidPoint | ) |

Sets up a skew factor to alter the way values are distributed.

This allows you to specify the slider value that should appear in the centre of the slider's visible range.

See also
  setSkewFactor, getSkewFactor, isSymmetricSkew

## ◆ getSkewFactor()

double Slider::getSkewFactor | ( |  | ) | const
| noexcept

Returns the current skew factor.

See setSkewFactor for more info.

See also
  setSkewFactor, setSkewFactorFromMidPoint, isSymmetricSkew

## ◆ isSymmetricSkew()

bool Slider::isSymmetricSkew | ( |  | ) | const
| noexcept

Returns the whether the skew is symmetric from the midpoint to both sides.

See setSkewFactor for more info.

See also
  getSkewFactor, setSkewFactor, setSkewFactorFromMidPoint

## ◆ setIncDecButtonsMode()

void Slider::setIncDecButtonsMode | ( | IncDecButtonMode | mode | ) |

When the style is IncDecButtons, this lets you turn on a mode where the mouse can be dragged on the buttons to drag the values.

By default this is turned off. When enabled, clicking on the buttons still works them as normal, but by holding down the mouse on a button and dragging it a little distance, it flips into a mode where the value can be dragged. The drag direction can either be set explicitly to be vertical or horizontal, or can be set to incDecButtonsDraggable_AutoDirection so that it depends on whether the buttons are side-by-side or above each other.

## ◆ setTextBoxStyle()

void Slider::setTextBoxStyle | ( | TextEntryBoxPosition | newPosition,
|  | bool | isReadOnly,
|  | int | textEntryBoxWidth,
|  | int | textEntryBoxHeight
| ) |  |

Changes the location and properties of the text-entry box.

Parameters

  newPosition | where it should go (or NoTextBox to not have one at all)
  isReadOnly | if true, it's a read-only display
  textEntryBoxWidth | the width of the text-box in pixels. Make sure this leaves enough room for the slider as well!
  textEntryBoxHeight | the height of the text-box in pixels. Make sure this leaves enough room for the slider as well!

See also
  setTextBoxIsEditable, getValueFromText, getTextFromValue

## ◆ getTextBoxPosition()

TextEntryBoxPosition Slider::getTextBoxPosition | ( |  | ) | const
| noexcept

Returns the status of the text-box.

See also
  setTextBoxStyle

## ◆ getTextBoxWidth()

int Slider::getTextBoxWidth | ( |  | ) | const
| noexcept

Returns the width used for the text-box.

See also
  setTextBoxStyle

## ◆ getTextBoxHeight()

int Slider::getTextBoxHeight | ( |  | ) | const
| noexcept

Returns the height used for the text-box.

See also
  setTextBoxStyle

## ◆ setTextBoxIsEditable()

void Slider::setTextBoxIsEditable | ( | bool | shouldBeEditable | ) |

Makes the text-box editable.

By default this is true, and the user can enter values into the textbox, but it can be turned off if that's not suitable.

See also
  setTextBoxStyle, getValueFromText, getTextFromValue

## ◆ isTextBoxEditable()

bool Slider::isTextBoxEditable | ( |  | ) | const
| noexcept

Returns true if the text-box is read-only.

See also
  setTextBoxStyle

## ◆ showTextBox()

void Slider::showTextBox | ( |  | ) |

If the text-box is editable, this will give it the focus so that the user can type directly into it.

This is basically the effect as the user clicking on it.

## ◆ hideTextBox()

void Slider::hideTextBox | ( | bool | discardCurrentEditorContents | ) |

If the text-box currently has focus and is being edited, this resets it and takes keyboard focus away from it.

Parameters

  discardCurrentEditorContents | if true, the slider's value will be left unchanged; if false, the current contents of the text editor will be used to set the slider position before it is hidden.

## ◆ setValue()

void Slider::setValue | ( | double | newValue,
|  | NotificationType | notification = `sendNotificationAsync`
| ) |  |

Changes the slider's current value.

This will trigger a callback to Slider::Listener::sliderValueChanged() for any listeners that are registered, and will synchronously call the valueChanged() method in case subclasses want to handle it.

Parameters

  newValue | the new value to set - this will be restricted by the minimum and maximum range, and will be snapped to the nearest interval if one has been set
  notification | can be one of the NotificationType values, to request a synchronous or asynchronous call to the valueChanged() method of any Slider::Listeners that are registered. A notification will only be sent if the Slider's value has changed.

## ◆ getValue()

double Slider::getValue | ( |  | ) | const

Returns the slider's current value.

## ◆ getValueObject()

Value & Slider::getValueObject | ( |  | ) |
| noexcept

Returns the Value object that represents the slider's current position.

You can use this Value object to connect the slider's position to external values or setters, either by taking a copy of the Value, or by using Value::referTo() to make it point to your own Value object.

See also
  Value, getMaxValue, getMinValueObject

## ◆ setRange() [1/2]

void Slider::setRange | ( | double | newMinimum,
|  | double | newMaximum,
|  | double | newInterval = `0`
| ) |  |

Sets the limits that the slider's value can take.

Parameters

  newMinimum | the lowest value allowed
  newMaximum | the highest value allowed
  newInterval | the steps in which the value is allowed to increase - if this is not zero, the value will always be (newMinimum + (newInterval * an integer)).

## ◆ setRange() [2/2]

void Slider::setRange | ( | Range< double > | newRange,
|  | double | newInterval
| ) |  |

Sets the limits that the slider's value can take.

Parameters

  newRange | the range to allow
  newInterval | the steps in which the value is allowed to increase - if this is not zero, the value will always be (newMinimum + (newInterval * an integer)).

## ◆ setNormalisableRange()

void Slider::setNormalisableRange | ( | NormalisableRange< double > | newNormalisableRange | ) |

Sets a NormalisableRange to use for the Slider values.

Parameters

  newNormalisableRange | the NormalisableRange to use

## ◆ getRange()

Range< double > Slider::getRange | ( |  | ) | const
| noexcept

Returns the slider's range.

## ◆ getMaximum()

double Slider::getMaximum | ( |  | ) | const
| noexcept

Returns the current maximum value.

See also
  setRange, getRange

## ◆ getMinimum()

double Slider::getMinimum | ( |  | ) | const
| noexcept

Returns the current minimum value.

See also
  setRange, getRange

## ◆ getInterval()

double Slider::getInterval | ( |  | ) | const
| noexcept

Returns the current step-size for values.

See also
  setRange, getRange

## ◆ getMinValue()

double Slider::getMinValue | ( |  | ) | const

For a slider with two or three thumbs, this returns the lower of its values.

For a two-value slider, the values are controlled with getMinValue() and getMaxValue(). A slider with three values also uses the normal getValue() and setValue() methods to control the middle value.

See also
  setMinValue, getMaxValue, TwoValueHorizontal, TwoValueVertical, ThreeValueHorizontal, ThreeValueVertical

## ◆ getMinValueObject()

Value & Slider::getMinValueObject | ( |  | ) |
| noexcept

For a slider with two or three thumbs, this returns the lower of its values.

You can use this Value object to connect the slider's position to external values or setters, either by taking a copy of the Value, or by using Value::referTo() to make it point to your own Value object.

See also
  Value, getMinValue, getMaxValueObject

## ◆ setMinValue()

void Slider::setMinValue | ( | double | newValue,
|  | NotificationType | notification = `sendNotificationAsync`,
|  | bool | allowNudgingOfOtherValues = `false`
| ) |  |

For a slider with two or three thumbs, this sets the lower of its values.

This will trigger a callback to Slider::Listener::sliderValueChanged() for any listeners that are registered, and will synchronously call the valueChanged() method in case subclasses want to handle it.

Parameters

  newValue | the new value to set - this will be restricted by the minimum and maximum range, and will be snapped to the nearest interval if one has been set.
  notification | can be one of the NotificationType values, to request a synchronous or asynchronous call to the valueChanged() method of any Slider::Listeners that are registered. A notification will only be sent if this value has changed.
  allowNudgingOfOtherValues | if false, this value will be restricted to being below the max value (in a two-value slider) or the mid value (in a three-value slider). If true, then if this value goes beyond those values, it will push them along with it.

See also
  getMinValue, setMaxValue, setValue

## ◆ getMaxValue()

double Slider::getMaxValue | ( |  | ) | const

For a slider with two or three thumbs, this returns the higher of its values.

For a two-value slider, the values are controlled with getMinValue() and getMaxValue(). A slider with three values also uses the normal getValue() and setValue() methods to control the middle value.

See also
  getMinValue, TwoValueHorizontal, TwoValueVertical, ThreeValueHorizontal, ThreeValueVertical

## ◆ getMaxValueObject()

Value & Slider::getMaxValueObject | ( |  | ) |
| noexcept

For a slider with two or three thumbs, this returns the higher of its values.

You can use this Value object to connect the slider's position to external values or setters, either by taking a copy of the Value, or by using Value::referTo() to make it point to your own Value object.

See also
  Value, getMaxValue, getMinValueObject

## ◆ setMaxValue()

void Slider::setMaxValue | ( | double | newValue,
|  | NotificationType | notification = `sendNotificationAsync`,
|  | bool | allowNudgingOfOtherValues = `false`
| ) |  |

For a slider with two or three thumbs, this sets the lower of its values.

This will trigger a callback to Slider::Listener::sliderValueChanged() for any listeners that are registered, and will synchronously call the valueChanged() method in case subclasses want to handle it.

Parameters

  newValue | the new value to set - this will be restricted by the minimum and maximum range, and will be snapped to the nearest interval if one has been set.
  notification | can be one of the NotificationType values, to request a synchronous or asynchronous call to the valueChanged() method of any Slider::Listeners that are registered. A notification will only be sent if this value has changed.
  allowNudgingOfOtherValues | if false, this value will be restricted to being above the min value (in a two-value slider) or the mid value (in a three-value slider). If true, then if this value goes beyond those values, it will push them along with it.

See also
  getMaxValue, setMinValue, setValue

## ◆ setMinAndMaxValues()

void Slider::setMinAndMaxValues | ( | double | newMinValue,
|  | double | newMaxValue,
|  | NotificationType | notification = `sendNotificationAsync`
| ) |  |

For a slider with two or three thumbs, this sets the minimum and maximum thumb positions.

This will trigger a callback to Slider::Listener::sliderValueChanged() for any listeners that are registered, and will synchronously call the valueChanged() method in case subclasses want to handle it.

Parameters

  newMinValue | the new minimum value to set - this will be snapped to the nearest interval if one has been set.
  newMaxValue | the new minimum value to set - this will be snapped to the nearest interval if one has been set.
  notification | can be one of the NotificationType values, to request a synchronous or asynchronous call to the valueChanged() method of any Slider::Listeners that are registered. A notification will only be sent if one or more of the values has changed.

See also
  setMaxValue, setMinValue, setValue

## ◆ addListener()

void Slider::addListener | ( | Listener * | listener | ) |

Adds a listener to be called when this slider's value changes.

## ◆ removeListener()

void Slider::removeListener | ( | Listener * | listener | ) |

Removes a previously-registered listener.

## ◆ setDoubleClickReturnValue()

void Slider::setDoubleClickReturnValue | ( | bool | shouldDoubleClickBeEnabled,
|  | double | valueToSetOnDoubleClick,
|  | ModifierKeys | singleClickModifiers = `ModifierKeys::altModifier`
| ) |  |

This lets you choose whether double-clicking or single-clicking with a specified key modifier moves the slider to a given position.

By default this is turned off, but it's handy if you want either of these actions to act as a quick way of resetting a slider. Just pass in the value you want it to go to when double-clicked. By default the key modifier is the alt key but you can pass in another key modifier, or none to disable this behaviour.

See also
  getDoubleClickReturnValue

## ◆ getDoubleClickReturnValue()

double Slider::getDoubleClickReturnValue | ( |  | ) | const
| noexcept

Returns the values last set by setDoubleClickReturnValue() method.

See also
  setDoubleClickReturnValue

## ◆ isDoubleClickReturnEnabled()

bool Slider::isDoubleClickReturnEnabled | ( |  | ) | const
| noexcept

Returns true if double-clicking to reset to a default value is enabled.

See also
  setDoubleClickReturnValue

## ◆ setChangeNotificationOnlyOnRelease()

void Slider::setChangeNotificationOnlyOnRelease | ( | bool | onlyNotifyOnRelease | ) |

Tells the slider whether to keep sending change messages while the user is dragging the slider.

If set to true, a change message will only be sent when the user has dragged the slider and let go. If set to false (the default), then messages will be continuously sent as they drag it while the mouse button is still held down.

## ◆ setSliderSnapsToMousePosition()

void Slider::setSliderSnapsToMousePosition | ( | bool | shouldSnapToMouse | ) |

This lets you change whether the slider thumb jumps to the mouse position when you click.

By default, this is true. If it's false, then the slider moves with relative motion when you drag it.

This only applies to linear bars, and won't affect two- or three- value sliders.

## ◆ getSliderSnapsToMousePosition()

bool Slider::getSliderSnapsToMousePosition | ( |  | ) | const
| noexcept

Returns true if setSliderSnapsToMousePosition() has been enabled.

## ◆ setPopupDisplayEnabled()

void Slider::setPopupDisplayEnabled | ( | bool | shouldShowOnMouseDrag,
|  | bool | shouldShowOnMouseHover,
|  | Component * | parentComponentToUse,
|  | int | hoverTimeout = `2000`
| ) |  |

If enabled, this gives the slider a pop-up bubble which appears while the slider is being dragged or hovered-over.

This can be handy if your slider doesn't have a text-box, so that users can see the value just when they're changing it.

If you pass a component as the parentComponentToUse parameter, the pop-up bubble will be added as a child of that component when it's needed. If you pass nullptr, the pop-up will be placed on the desktop instead (note that it's a transparent window, so if you're using an OS that can't do transparent windows you'll have to add it to a parent component instead).

By default the popup display shown when hovering will remain visible for 2 seconds, but it is possible to change this by passing a different hoverTimeout value. A value of -1 will cause the popup to remain until a mouseExit() occurs on the slider.

## ◆ getCurrentPopupDisplay()

Component * Slider::getCurrentPopupDisplay | ( |  | ) | const
| noexcept

If a popup display is enabled and is currently visible, this returns the component that is being shown, or nullptr if none is currently in use.

See also
  setPopupDisplayEnabled

## ◆ setPopupMenuEnabled()

void Slider::setPopupMenuEnabled | ( | bool | menuEnabled | ) |

If this is set to true, then right-clicking on the slider will pop-up a menu to let the user change the way it works.

By default this is turned off, but when turned on, the menu will include things like velocity sensitivity, and for rotary sliders, whether they use a linear or rotary mouse-drag to move them.

## ◆ setScrollWheelEnabled()

void Slider::setScrollWheelEnabled | ( | bool | enabled | ) |

This can be used to stop the mouse scroll-wheel from moving the slider.

By default it's enabled.

## ◆ isScrollWheelEnabled()

bool Slider::isScrollWheelEnabled | ( |  | ) | const
| noexcept

Returns true if the scroll wheel can move the slider.

## ◆ getThumbBeingDragged()

int Slider::getThumbBeingDragged | ( |  | ) | const
| noexcept

Returns a number to indicate which thumb is currently being dragged by the mouse.

This will return 0 for the main thumb, 1 for the minimum-value thumb, 2 for the maximum-value thumb, or -1 if none is currently down.

## ◆ startedDragging()

virtual void Slider::startedDragging | ( |  | ) |
| virtual

Callback to indicate that the user is about to start dragging the slider.

See also
  Slider::Listener::sliderDragStarted

## ◆ stoppedDragging()

virtual void Slider::stoppedDragging | ( |  | ) |
| virtual

Callback to indicate that the user has just stopped dragging the slider.

See also
  Slider::Listener::sliderDragEnded

## ◆ valueChanged()

virtual void Slider::valueChanged | ( |  | ) |
| virtual

Callback to indicate that the user has just moved the slider.

See also
  Slider::Listener::sliderValueChanged

## ◆ getValueFromText()

virtual double Slider::getValueFromText | ( | const String & | text | ) |
| virtual

Subclasses can override this to convert a text string to a value.

When the user enters something into the text-entry box, this method is called to convert it to a value. The default implementation just tries to convert it to a double.

See also
  getTextFromValue

## ◆ getTextFromValue()

virtual String Slider::getTextFromValue | ( | double | value | ) |
| virtual

Turns the slider's current value into a text string.

Subclasses can override this to customise the formatting of the text-entry box.

The default implementation just turns the value into a string, using a number of decimal places based on the range interval. If a suffix string has been set using setTextValueSuffix(), this will be appended to the text.

See also
  getValueFromText

## ◆ setTextValueSuffix()

void Slider::setTextValueSuffix | ( | const String & | suffix | ) |

Sets a suffix to append to the end of the numeric value when it's displayed as a string.

This is used by the default implementation of getTextFromValue(), and is just appended to the numeric value. For more advanced formatting, you can override getTextFromValue() and do something else.

## ◆ getTextValueSuffix()

String Slider::getTextValueSuffix | ( |  | ) | const

Returns the suffix that was set by setTextValueSuffix().

## ◆ getNumDecimalPlacesToDisplay()

int Slider::getNumDecimalPlacesToDisplay | ( |  | ) | const
| noexcept

Returns the best number of decimal places to use when displaying this slider's value.

It calculates the fewest decimal places needed to represent numbers with the slider's interval setting.

See also
  setNumDecimalPlacesToDisplay

## ◆ setNumDecimalPlacesToDisplay()

void Slider::setNumDecimalPlacesToDisplay | ( | int | decimalPlacesToDisplay | ) |

Modifies the best number of decimal places to use when displaying this slider's value.

See also
  getNumDecimalPlacesToDisplay

## ◆ proportionOfLengthToValue()

virtual double Slider::proportionOfLengthToValue | ( | double | proportion | ) |
| virtual

Allows a user-defined mapping of distance along the slider to its value.

The default implementation for this performs the skewing operation that can be set up in the setSkewFactor() method. Override it if you need some kind of custom mapping instead, but make sure you also implement the inverse function in valueToProportionOfLength().

Parameters

  proportion | a value 0 to 1.0, indicating a distance along the slider

Returns
  the slider value that is represented by this position

See also
  valueToProportionOfLength

## ◆ valueToProportionOfLength()

virtual double Slider::valueToProportionOfLength | ( | double | value | ) |
| virtual

Allows a user-defined mapping of value to the position of the slider along its length.

The default implementation for this performs the skewing operation that can be set up in the setSkewFactor() method. Override it if you need some kind of custom mapping instead, but make sure you also implement the inverse function in proportionOfLengthToValue().

Parameters

  value | a valid slider value, between the range of values specified in setRange()

Returns
  a value 0 to 1.0 indicating the distance along the slider that represents this value

See also
  proportionOfLengthToValue

## ◆ getPositionOfValue()

float Slider::getPositionOfValue | ( | double | value | ) | const

Returns the X or Y coordinate of a value along the slider's length.

If the slider is horizontal, this will be the X coordinate of the given value, relative to the left of the slider. If it's vertical, then this will be the Y coordinate, relative to the top of the slider.

If the slider is rotary, this will throw an assertion and return 0. If the value is out-of-range, it will be constrained to the length of the slider.

## ◆ snapValue()

virtual double Slider::snapValue | ( | double | attemptedValue,
|  | DragMode | dragMode
| ) |  |
| virtual

This can be overridden to allow the slider to snap to user-definable values.

If overridden, it will be called when the user tries to move the slider to a given position, and allows a subclass to sanity-check this value, possibly returning a different value to use instead.

Parameters

  attemptedValue | the value the user is trying to enter
  dragMode | indicates whether the user is dragging with the mouse; notDragging if they are entering the value using the text box or other non-dragging interaction

Returns
  the value to use instead

## ◆ updateText()

void Slider::updateText | ( |  | ) |

This can be called to force the text box to update its contents.

(Not normally needed, as this is done automatically).

## ◆ isHorizontal()

bool Slider::isHorizontal | ( |  | ) | const
| noexcept

True if the slider moves horizontally.

## ◆ isVertical()

bool Slider::isVertical | ( |  | ) | const
| noexcept

True if the slider moves vertically.

## ◆ isRotary()

bool Slider::isRotary | ( |  | ) | const
| noexcept

True if the slider is in a rotary mode.

## ◆ isBar()

bool Slider::isBar | ( |  | ) | const
| noexcept

True if the slider is in a linear bar mode.

## ◆ isTwoValue()

bool Slider::isTwoValue | ( |  | ) | const
| noexcept

True if the slider has two thumbs.

## ◆ isThreeValue()

bool Slider::isThreeValue | ( |  | ) | const
| noexcept

True if the slider has three thumbs.

## ◆ paint()

void Slider::paint | ( | Graphics & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ resized()

void Slider::resized | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseDown()

void Slider::mouseDown | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseUp()

void Slider::mouseUp | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseDrag()

void Slider::mouseDrag | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseDoubleClick()

void Slider::mouseDoubleClick | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseWheelMove()

void Slider::mouseWheelMove | ( | const MouseEvent & | ,
|  | const MouseWheelDetails & |
| ) |  |
| overridevirtual

Reimplemented from Component.

## ◆ modifierKeysChanged()

void Slider::modifierKeysChanged | ( | const ModifierKeys & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ lookAndFeelChanged()

void Slider::lookAndFeelChanged | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ enablementChanged()

void Slider::enablementChanged | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ focusOfChildComponentChanged()

void Slider::focusOfChildComponentChanged | ( | FocusChangeType |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ colourChanged()

void Slider::colourChanged | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseMove()

void Slider::mouseMove | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseExit()

void Slider::mouseExit | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseEnter()

void Slider::mouseEnter | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ keyPressed()

bool Slider::keyPressed | ( | const KeyPress & |  | ) |
| overridevirtual

Reimplemented from Component.

## Member Data Documentation

## ◆ onValueChange

std::function<void()> Slider::onValueChange

You can assign a lambda to this callback object to have it called when the slider value is changed.

## ◆ onDragStart

std::function<void()> Slider::onDragStart

You can assign a lambda to this callback object to have it called when the slider's drag begins.

## ◆ onDragEnd

std::function<void()> Slider::onDragEnd

You can assign a lambda to this callback object to have it called when the slider's drag ends.

## ◆ valueFromTextFunction

std::function<double (const String&)> Slider::valueFromTextFunction

You can assign a lambda that will be used to convert textual values to the slider's normalised position.

## ◆ textFromValueFunction

std::function<String (double)> Slider::textFromValueFunction

You can assign a lambda that will be used to convert the slider's normalised position to a textual value.

The documentation for this class was generated from the following file:

- juce_Slider.h